class ANIMAL
--
-- Classe decrivant les caracteristiques et actions des animaux
--

inherit
	CREATURE
		rename
			naissance as naissance_creature
		redefine
			action,
			deplacer,
			details
		end

creation
	naissance

feature
	-- effectue une action au hasard parmi les actions possibles
	action(creatures: FAST_ARRAY[CREATURE]; objets: FAST_ARRAY[OBJET]) is
		require else
			vivante
		local
			points: INTEGER
		do
			if get_random_integer(10) <= 5 then
				Precursor(creatures, objets)
			else
				points := 1 + get_random_integer(5)
				soigner(points)
				io.put_string(nom.out + " broute un peu d'herbe, cela lui rapporte " + points.out + " points de vie %N")	
			end
		end


	-- depense une somme d'argent
	depenser(somme: INTEGER) is
		do
			io.put_string(nom.out + " se dit qu'il aime bien les methodes retardees, mais il ne depensera quand meme jamais rien de sa courte vie%N")
		end


	-- permet de faire dplacer de faon alatoire une crature
	deplacer is
		require else
			vie > 0
			position_x >= 0
			position_x < taille_x
			position_y >= 0
			position_y < taille_y
		local
			destination_x, destination_y: INTEGER
		do
			destination_x := position_x + get_random_integer(5) - 1
			destination_y := position_y + get_random_integer(5) - 1

			if destination_x < 0 then
				destination_x := 0
			end

			if destination_x >= taille_x  then
				destination_x := taille_x - 1
			end

			if destination_y < 0 then
				destination_y := 0
			end

			if destination_y >= taille_y  then
				destination_y := taille_y - 1
			end

			position_x := destination_x
			position_y := destination_y

			debug
				io.put_string(nom.out + " se dplace en " + position_x.out + ", " + position_y.out + "%N")
			end
		ensure then
			position_x >= 0
			position_x < taille_x
			position_y >= 0
			position_y < taille_y			
		end


	-- affiche les donnees de l'animal
	details is
		do
			io.put_string(position_x.out + ", " + position_y.out + "	" + nom.out + "	vie : " + vie.out + "%N")
		end


	-- gagne une somme d'argent
	gagner(somme: INTEGER) is
		do
			io.put_string(nom.out + " se dit qu'il aime bien les methodes retardees, mais il ne gagnera quand meme jamais rien de sa courte vie%N")
		end


	-- retourne le type sous forme d'un STRING
	get_type: STRING is
		do
			result := "ANIMAL"
		end


	-- naissance d'un animal
	naissance(x, y, v: INTEGER; n: STRING) is
		do
			naissance_creature(x, y, v, n)
			debug
				io.put_string("Naissance de l'animal " + nom.out + "%N")
			end
		end


end -- class ANIMAL
