class HUMAIN
--
-- Classe decrivant les caracteristiques et actions des humains
--

inherit
	CREATURE
		rename
			naissance as naissance_creature
		redefine
			action,
			details,
			get_richesse
		end ;

creation
	naissance

feature
	-- Extension
	richesse: INTEGER	-- argent de l'humain


	-- effectue une action au hasard parmi les actions possibles
	action(creatures: FAST_ARRAY[CREATURE]; objets: FAST_ARRAY[OBJET]) is
		require else
			vivante
		do
			-- en fonction de l'environnement, on choisit une
			-- action  effectuer. Dans l'ordre
			-- - se faire prendre en photo avec le superheros
			-- - manger les animaux
			-- - action des creatures basiques
			if creature_presente(creatures, "SUPERHEROS") then
				-- un superheros se trouve au meme endroit 
				-- que l'humain
				io.put_string(nom.out + " se fait prendre en photo aux cotes de " + get_premiere_creature(creatures, "SUPERHEROS").get_nom.out + "%N")
			elseif creature_presente(creatures, "ANIMAL") then
				-- manger un animal present
				manger_animal(get_premiere_creature(creatures, "ANIMAL"))
			else
				-- effectue une des autres 
				-- actions disponibles
				Precursor(creatures, objets)
			end
		end


	-- depense une somme d'argent
	depenser(somme: INTEGER) is
		require
			somme >= 0
		do
			-- pas de decouvert autorise, dans notre monde on ne se
			-- contente d etout prendre aux gens s'ils n'ont pas 
			-- assez pour payer (le beau concept... !)
			richesse := richesse - somme.min(richesse)
		ensure
			richesse >= 0
		end


	-- affiche les donnees de l'humain
	details is
		do
			io.put_string(position_x.out + ", " + position_y.out + "	" + nom.out + "	vie : " + vie.out + "	" + richesse.out + " batdollars%N")
		end


	-- gagne une somme d'argent
	gagner(somme: INTEGER) is
		require
			somme >= 0
		do
			richesse := richesse + somme
		ensure
			richesse >= 0
		end


	-- retourne la richesse de l'humain
	get_richesse: INTEGER is
		do
			result := richesse
		end


	-- retourne le type sous forme d'un STRING
	get_type: STRING is
		do
			result := "HUMAIN"
		end


	-- mange un animal
	manger_animal(creature: CREATURE) is
		require
			vivante
			creature.get_type.is_equal("ANIMAL")	-- pas de canibalisme
		local
			points: INTEGER
		do
			if get_random_integer(3) = 3 then	-- une chance sur quatre
				points := (creature.get_vie / 2).floor
				creature.mourir
				vie := vie + points
				io.put_string(nom.out + " se regale en mangeant " + creature.get_nom.out + ", cela lui rapporte " + points.out + " points de vie.%N")
			else
				io.put_string(nom.out + " aurait aim manger " + creature.get_nom.out + ", mais celui ci s'echappe.%N")
			end
		end


	-- naissance d'un humain
	naissance (x, y, v: INTEGER; n: STRING) is
		do
			naissance_creature(x, y, v, n);

			-- notre monde comporte le beau principe d'equite
			-- materielle des hommes a leur naissance : ils
			-- sont tous aussi riches les uns que les autres
			richesse := 1000

			debug
				io.put_string("Naissance de l'humain " + nom.out + "%N")
			end
		end

end -- class HUMAIN
