class SUPERHEROS
--
-- Classe decrivant les caracteristiques et actions des superheros
--

inherit
	HUMAIN
		rename
			naissance as naissance_humain
		undefine
			deplacer
		redefine
			action,
			details,
			get_type
		end

insert
	ANIMAL
		rename
			action as action_animal
			naissance as naissance_animal
		undefine
			details,
			depenser,
			emprisonner,
			gagner,
			get_richesse,
			get_type,
			liberer,
			soigner
		end


creation
	naissance

feature
	-- effectue une action au hasard parmi les actions possibles
	action(creatures: FAST_ARRAY[CREATURE]; objets: FAST_ARRAY[OBJET]) is
		require else
			vivante
		local
			animal:	CREATURE
		do
			-- en fonction de l'environnement, on choisit une
			-- action  effectuer. Dans l'ordre
			-- - combattre les supermechants
			-- - action des humains
			-- - action des animaux
			if creature_presente(creatures, "SUPERMECHANT") then
				-- un supermechant se trouve au meme endroit 
				-- que le superheros
				arreter(get_premiere_creature(creatures, "SUPERMECHANT"))
			else
				if creature_presente(creatures, "ANIMAL") then
					-- soigne un animal s'il est trop faible
					animal := get_premiere_creature(creatures, "ANIMAL")
					if animal.get_vie < 10 then
						soigner_creature(animal)
--					else
						-- effectue une des autres 
						-- actions disponibles
--						Precursor(creatures, objets)
					end
				else
					-- effectue une des autres 
					-- actions disponibles
					Precursor(creatures, objets)
				end
			end
		end


	-- essaie d'arreter une creature
	arreter(creature: CREATURE) is
		require
			vivante
			creature.get_type.is_equal("SUPERMECHANT")
		local
			somme: INTEGER
		do
			if get_random_integer(2) = 2 then	-- une chance sur trois
				-- youhou, le superheros a reussi a emprisonner 
				-- le supermechant. Elle lui confisque sa 
				-- richesse et l'ammene en prison
				io.put_string(nom.out + " parvient a arreter " + creature.get_nom.out + " et le place en prison%N")
				creature.emprisonner

				-- le superheros prend la moitie du butin de 
				-- la creature "pour ses pauvres"
				somme := (creature.get_richesse / 2).floor
				gagner(somme)
				creature.depenser(somme)
			else
				io.put_string(creature.get_nom.out + " a encore echappe a " + nom.out + "!!%N")
			end
		end


	-- affiche les donnees du superheros
	details is
		do
			io.put_string(position_x.out + ", " + position_y.out + "	" + nom.out + "	vie : " + vie.out + "	" + richesse.out + " batdollars%N")
		end


	-- retourne le type sous forme d'un STRING
	get_type: STRING is
		do
			result := "SUPERHEROS"
		end


	-- naissance d'un superheros
	naissance(x, y, v: INTEGER; n: STRING) is
		do
			naissance_humain(x, y, v, n)
			debug
				io.put_string("Naissance du superheros " + nom.out + "%N")
			end
		end


	-- soigne une creature si elle est trop faible
	soigner_creature(creature: CREATURE) is
		require
			vivante
		local
			points: INTEGER
		do
			if creature.get_vie < 10 then
				points := 1 + get_random_integer(10)
				creature.soigner(points)
				io.put_string(nom.out + " soigne " + creature.get_nom.out + " et lui donne " + points.out + " points de vie.%N")
			end
		end


	-- si si, la teleportation ca existe
	teleporter_x_y(x, y: INTEGER) is
		require
			vivante
			x >= 0
			x < taille_x
			y >= 0
			y < taille_y
		do
			position_x := x
			position_y := y	
			io.put_string(nom.out + " se teleporte en " + x.out + "," + y.out + "!%N")
		end

end -- class SUPERHEROS
